require "rttlib"
require "rfsm"
require "rfsm_rtt"
require "utils"

local tc=rtt.getTC();
local fsm
local fqn_out, events_in

function pingFunction()
	print("******* In Ping Function *************")
end

function pongFunction()
	print(" ****************In Pong Function ***********")
end

function configureHook()
	-- load state machine
	fsm = rfsm.init(rfsm.load("/home/aviator/orocos_test/Lua_State_Machine/fsm.lua"))
	events_in = rtt.InputPort("string")
	tc:addEventPort(events_in, "events", "rFSM event input port")
	fsm.getevents = rfsm_rtt.gen_read_events(events_in)

	-- create output port and write the state of the FSM
	fqn_out = rtt.OutputPort("string")
	tc:addPort(fqn_out, "rFSM_current_state", "rFSM current active state")
	fsm.step_hook=utils.advise("before", fsm.step_hook, rfsm_rtt.gen_write_fqn(fqn_out))
	return true
end

function updateHook() rfsm.run(fsm) end

function cleanupHook()
	--clean up the created ports
	tc:removePort(fqn_out:info().name)
	tc:removePort(events_in:info().name)
	fqn_out:delete()
	events_in_delete()
end
